# Morphologische Filter (Erosion, Dilation, Opening und Closing) anwenden.
library(EBImage)

# Originalbild laden
imgColor <- readImage("testimages/smiley.png")
# zu Graubild machen
imgGray <- channel(imgColor, "luminance")
# Binärbild mit Thresholding und Otsu
img <- imgGray > otsu(imgGray)
img <- 1.0 - img # Schwarz ist Vordergrund

# Strukturelement erstellen
struct <- makeBrush(5, "disc") # 5x5 Kreis

# Erosion
eroded <- erode(img, struct)
eroded <- 1.0 - eroded # Schwarz = Vordergrund

# Dilation
dilated <- dilate(img, struct)
dilated <- 1.0 - dilated # Schwarz = Vordergrund

# Opening
opened <- opening(img, struct)
opened <- 1.0 - opened # Schwarz = Vordergrund

# Closing
closed <- closing(img, struct)
closed <- 1.0 - closed # Schwarz = Vordergrund


# Bilder speichern
# ================
writeImage(eroded, "testimages/out_smileyEroded.png")
writeImage(dilated, "testimages/out_smileyDilated.png")
writeImage(opened, "testimages/out_smileyOpened.png")
writeImage(closed, "testimages/out_smileyClosed.png")

